# Import des bibliothèques nécessaires au fonctionnement du script
import matplotlib.pyplot as plt # permet le tracé de l'histogramme
import statistics as stats # permet de faire des calculs de statisques
from math import* # ici cette fonction va permettre de calculer une racine carrée
from time import* # ici ce module va permettre d'améliorer l'affichage

# création de notre liste de mesures
L = [0.1095,0.1075,0.1020,0.1030,0.1010,0.1000,0.096,0.095,0.090,0.0925,0.0990]


# calcule de la moyenne associée à la série de mesures
moyenne = stats.mean(L)
# Calcul de l'écart-type associé à la série de mesures
ecartype = stats.stdev(L)
# Calcul de l'incertitude-type associée à la série de mesures
incertitude_type = ecartype/sqrt(len(L))
# affichage de la moyenne arrondie
print("La moyenne associée à la série de mesures est: ",round(moyenne,4),"mol.")
# affichage de l'écart-type arrondie
print("L'écartype associé à la série de mesures est: ",round(ecartype,4),"mol.")
# affichage de l'incertitude_type arrondie
print("L'incertitude-type associée à la série de mesures est: ",round(incertitude_type,4),"mol.")


# demande à l'utilisateur la valeur de référence
reference = eval(input("veuillez entrer la valeur de référence "))

# Calcul pour savoir si la valeur de référence est comprise entre la moyenne
# moins l'incertitude_type et la moyenne plus l'incertitude_type.
# Si c'est le cas, on affiche une certaine phrase sinon une certaine autre.

if reference > moyenne-incertitude_type and reference < moyenne+incertitude_type:
    print("Dans les conditions de l'expérience, avec un échantillon de",len(L)\
,"mesures, la quantité de matière d'H2O2 dans 100 mL de solution vaut"\
,round(moyenne,4),"mol avec une incertitude-type de",round(incertitude_type,4),"mol.\
 Notre mesure est donc compatible avec la valeur de référence car celle-ci\
 est comprise entre",round(moyenne-incertitude_type,4),"mol et",\
round(moyenne+incertitude_type,4),"mol.")
else :
    print("Dans les conditions de l'expérience, avec un échantillon de",len(L)\
,"mesures, la quantité de matière d'H2O2 dans 100 mL de solution vaut"\
,round(moyenne,4),"mol avec une incertitude-type de",round(incertitude_type,4),"mol.\
 Notre mesure n'est donc pas compatible avec la valeur de référence car celle-ci\
 n'est pas comprise entre",round(moyenne-incertitude_type,4),"mol et",\
round(moyenne+incertitude_type,4),"mol.")


# Ceci permet un meilleur rendu en affichant cette phrase après un certain temps
sleep(15)
print("Voici l'histogramme associé à la série de valeurs")


# création d'un histogramme
plt.hist(L)

# Noms des axes
plt.xlabel("Quantité de matière d'H2O2 dans 100 mL de solution (en mol)")
plt.ylabel("Nombre de mesures ayant été répertoriées par intervalle")

# Titre du graphique
plt.title("Mesures de la quantité de matière d'H2O2 par intervalle (d'apparition)")

# Affichage du graphique après un certain temps à la suite de la phrase
sleep(2)
plt.show()
